
import processing.sound.*;

Pulse pulse;

interface IObservingInternalSynth extends IObservingController, IMusicObserver {
  
}


class BasicSynth implements IObservingInternalSynth {
  IBus innerBus;
  IFreqStrategy fs;
  int channel;
  
  Oscillator osc;
  Env env; 
  Reverb reverb;
  Delay delay;
  
  float attackTime = 0.001;
  float sustainTime = 0.004;
  float sustainLevel = 0.3;
  float releaseTime = 0.2;
  
  BasicSynth(PApplet app, Oscillator o, int c, IFreqStrategy afs, IBus abus) {
    channel=c;
    fs = afs;
    innerBus = abus;

    osc = o; //new Pulse(app);
    osc.amp(0.3);
    osc.play();  
    
    env = new Env(app);
    
    delay = new Delay(app);
    delay.feedback(0.3);
    delay.process(osc, 0.25);
    
    reverb = new Reverb(app);
    //reverb.process(osc);
    
    reverb.room(0.25);
    reverb.damp(0.8);
    reverb.wet(0.3);
    
    
  }
  void setBus(IBus bus) { innerBus = bus; }
  IBus getBus() { return innerBus; }
  void postToBus() { }
  IFreqStrategy getFreqStrategy() { return fs; }
  void setFreqStrategy(IFreqStrategy ifs) { fs = ifs; }
  float makeCorrectedFreq(float y) { return fs.corrected(fs.rawFreq(y)); }
  void scanBus() {
    int bang = 0;  
    for (IMessage m : innerBus.getBangs(channel)) { 
      env.play(osc,attackTime, sustainTime, sustainLevel, releaseTime);
    }
   
    for (IMessage m : innerBus.getFloats(channel)) {
      float[] xs = ((IFloatMessage)m).getFloats();
      osc.play(makeCorrectedFreq(xs[1]), 0.5);
    }      
  }  
}
