import arttoys.core.*;

import java.util.Random;

IAutomatonToy toy;
Uids _ids = new Uids();
Random rnd = new Random();
IBus mainBus = new BasicBus();

ColorTool colorTool = new ColorTool(this);

NoteCalculator nc = new NoteCalculator();
IFreqStrategy fs = new ScaleBasedFreqStrategy(nc);  

ArrayList<IObservingController> instruments = new ArrayList<IObservingController>();

GbloinkWorld makeGbloink() {
  nc.setCurrent("minor");
  Oscillator[] oscs = { new Pulse(this), new SinOsc(this), new TriOsc(this) };
  for (int i=0;i<3;i++) {
    //instruments.add( new ObInGbloink2ArtToys2("localhost", 9004, "/channel"+i, i, fs, mainBus ) );
      instruments.add( new BasicSynth(this,oscs[i],i,fs,mainBus) );
  }

  return new GbloinkWorld(new Ball(0,color(255,0,0),width/2 + random(100)-100,height/2+random(200)-100,2,2, mainBus),
                          new Ball(1,color(0,255,0),width/2 + random(100)-100,height/2+random(200)-100,2,2, mainBus),
                          new Ball(2,color(0,0,255),width/2 + random(100)-100,height/2+random(200)-100,2,2, mainBus),
                          colorTool
                          
  );
}

void reset() {
  mainBus.reset();
  toy = makeGbloink();
  toy.reset();
  toy.sizeInSetup();  
}

int GLOBAL_WIDE = 1000;
int GLOBAL_HIGH = 700;

void settings() {
  size(GLOBAL_WIDE,GLOBAL_HIGH);
}

void setup() {
  reset();
  stroke(color(200,200,30));
}
 

void draw() {
  mainBus.reset();
  toy.nextStep();  
  toy.draw();
  toy.postToBus();

  
  for (IObservingController in : instruments) {
    //println(in.getClass().getName());
    in.scanBus();
  }

}

void mouseClicked() { toy.struck(mouseX,mouseY); }

void keyPressed() {
  if (key==' ') { reset(); return; }
  toy.keyPressed(key); 
  nc.keyPressedUpdate(key);
}

void mousePressed() { toy.mousePressed(mouseX, mouseY); }
void mouseDragged() { toy.mouseDragged(mouseX, mouseY); }
void mouseReleased() { toy.mouseReleased(); }
